import { isString } from 'lodash';
import { useContext } from 'react';
import { useId } from '@react-devui/hooks';
import { cloneHTMLElement } from '../../utils';
import { DFormUpdateContext } from '../form';
export function DBaseInput(props) {
    const { children, dFormControl, dLabelFor } = props;
    //#region Context
    const updateForm = useContext(DFormUpdateContext);
    //#endregion
    const uniqueId = useId();
    const supportForm = updateForm && dFormControl;
    const attrs = supportForm
        ? Object.assign({ 'data-form-item-label-for': dLabelFor }, dFormControl.inputAttrs) : {};
    return children({
        render: (el) => {
            var _a, _b;
            return cloneHTMLElement(el, Object.assign(Object.assign({}, attrs), { id: (_a = el.props.id) !== null && _a !== void 0 ? _a : (dLabelFor ? `form-item-label-for-${uniqueId}` : undefined), 'aria-describedby': [el.props['aria-describedby'], (_b = dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.inputAttrs) === null || _b === void 0 ? void 0 : _b['aria-describedby']]
                    .filter((describedby) => isString(describedby))
                    .join(' ') }));
        },
    });
}
