import type { FormControlStatus } from './abstract-control';
import type { AsyncValidatorFn, ValidatorFn } from './validators';
import { AbstractControl } from './abstract-control';
export interface FormControlState<V> {
    value: V;
    disabled?: boolean;
}
export declare class FormControl<V> extends AbstractControl<V> {
    readonly defaultState: FormControlState<V> | V;
    protected _value: V;
    protected _status: FormControlStatus;
    constructor(formState: FormControlState<V> | V, validators?: ValidatorFn | ValidatorFn[] | null, asyncValidator?: AsyncValidatorFn | AsyncValidatorFn[] | null);
    setValue(value: V, onlySelf?: boolean): void;
    patchValue(value: V, onlySelf?: boolean): void;
    reset(formState?: V | FormControlState<V>, onlySelf?: boolean): void;
    protected _updateValue(): void;
    protected _forEachChild(): void;
    protected _anyControls(): boolean;
    protected _allControlsDisabled(): boolean;
    protected _isFormStateObject(formState: FormControlState<V> | V): formState is FormControlState<V>;
    private _applyFormState;
}
